
	//Model of jsobject. All should have at least those methods implemented
	JsCalendar = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsCalendar";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		this.date				= new Date;
		this.day				= this.date.getDate();
		this.month				= this.date.getMonth()
		this.year				= this.date.getYear();
		if (browserType == "ie")
			this.year = this.date.getYear();
		else
			this.year = this.date.getYear() + 1900;

		// array of total days in each month
		this.totalDays = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		// leap year correction
		if (this.year % 4 == 0)
			this.totalDays[1] = 29;

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.datetable			= document.createElement("table");
		this.monthrow			= this.datetable.insertRow(0);
		this.weekdayrow			= this.datetable.insertRow(1);

		this.previouscell		= this.monthrow.insertCell(0);
		this.monthcell			= this.monthrow.insertCell(1);
		this.nextcell			= this.monthrow.insertCell(2);

		this.previousbutton = eval(this.id + "button	= new JsImageButton('" + this.id + "button')");
		this.nextbutton = eval(this.id + "button	= new JsImageButton('" + this.id + "button')");

		this.previousbutton.setSource("images/prev_arrow.gif");
		this.nextbutton.setSource("images/next_arrow.gif");

		this.previousbutton.setAttribute("parent", this.name);
		this.previousbutton.setAttribute("action", "decrease");
		this.nextbutton.setAttribute("parent", this.name);
		this.nextbutton.setAttribute("action", "increase");

		this.previousbutton.setEvent("click", changeMonth);
		this.nextbutton.setEvent("click", changeMonth);

		this.previouscell.appendChild(this.previousbutton.output);
		this.nextcell.appendChild(this.nextbutton.output);

		this.nextcell.align = "right";

		this.monthcell.colSpan = 5;
		this.monthcell.innerHTML = translation[lang]["month"][this.month] + " " + this.year;
		this.monthcell.align = "center";

		this.output.className	= "calendarOutput";
		this.datetable.className	= "calendarTable";
		this.previouscell.className	= "calendarMonthCell";
		this.monthcell.className	= "calendarMonthCell";
		this.nextcell.className	= "calendarMonthCell";

		for (var js_i in translation[lang]["week_abreviation"])
		{
			currentcell = this.weekdayrow.insertCell(js_i);
			currentcell.innerHTML = translation[lang]["week_abreviation"][js_i];
			currentcell.className	= "calendarWeekCell";
		}

		for (var js_i=0; js_i<6; js_i++)
		{
			temp = this.datetable.insertRow(2);
			for (var js_j=0; js_j<=6; js_j++)
			{
				cell = temp.insertCell(temp.cells.length);
				cell.innerHTML = "&nbsp;";
				cell.className = "calendarEmptyCell";
			}
		}

		for (var js_i=0; js_i <= 31; js_i++)
		{
			labelname = this.id + "callabel"+js_i;
			eval(labelname+" = new JsLabel('"+labelname+"')");
			this.childList[js_i] = eval(labelname);
			if (js_i < 10)
				var dayValue = "0" + js_i;
			else
				var dayValue = js_i;
			this.childList[js_i].setAttribute("parent",labelname);
			this.childList[js_i].setAttribute("parentObj",this.name);
			this.childList[js_i].setEvent("mousedown",setCalValue);
			this.childList[js_i].setEvent("mouseover",setCalendarItemOver);
			this.childList[js_i].setEvent("mouseout",setCalendarItemOut);
			this.childList[js_i].setEvent("click",setCalendarItemOut);
			this.childList[js_i].setEvent("click",hideActiveHidden);
			this.childList[js_i].setValue(dayValue);
			this.childList[js_i].setHeight(18);
			this.childList[js_i].setClass("calendarDayCell");
		}

		this.output.appendChild(this.datetable);
		this.output.style.width = 200;
		this.output.style.height = 156;

		this.build();
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsCalendar.prototype.build = function()
	{
		this.date = new Date(this.year, this.month, 1);
		this.firstDayOfMonth = this.date.getDay();
		this.date.setDate(31);
		this.lastDayOfMonth = this.date.getDay();

		this.cellCount = 0;
		this.rowCount  = 1;
		this.currRow   = 2;

		for (var js_i in this.childList)
		{
			if(this.childList[js_i].output.parentNode)
				this.childList[js_i].output.parentNode.removeChild(this.childList[js_i].output);
		}

		// start displaying dates
		// display blank spaces until the first day of the month
		var temp = this.datetable.rows[this.currRow];
		for (var js_i=0; js_i<this.firstDayOfMonth; js_i++)
		{
			var cell = temp.cells[js_i];
			cell.className = "calendarEmptyCell";
			cell.innerHTML = "&nbsp;";
			this.cellCount++;
		}

		this.currCell = this.cellCount;

		// counter to track the current date
		this.dayCount=1;
		while (this.dayCount <= this.totalDays[this.month])
		{
			if (this.cellCount % 7 == 0 && (this.firstDayOfMonth != 0 || this.dayCount > 7))
			{
				this.currRow++;
				temp = this.datetable.rows[this.currRow];
				this.rowCount++;
				this.currCell = 0;
			}

			// print date
			var cell = temp.cells[this.currCell];
			cell.innerHTML = "";
			cell.appendChild(this.childList[this.dayCount].output);
			cell.className = "calendarDayCell";
			this.dayCount++;
			this.cellCount++;
			this.currCell++;
		}

		while (this.cellCount % 7 != 0)
		{
			var cell = temp.cells[this.currCell];
			cell.className = "calendarEmptyCell";
			cell.innerHTML = "&nbsp;";
			this.cellCount++;
			this.currCell++;
		}

		if (this.currRow < 7)
		{
			this.currRow++;
			temp = this.datetable.rows[this.currRow];
			for (var js_i=0; js_i<7; js_i++)
			{
				var cell = temp.cells[js_i];
				cell.className = "calendarEmptyCell";
				cell.innerHTML = "&nbsp;";
				this.cellCount++;
			}
		}
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Content Methods
	********************************************/



	/********************************************
				End of Content Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsCalendar.prototype.getValue = function()
	{
		var js_day = this.day;
		var js_month = parseInt(this.month) + 1;
		var js_year = this.year;

		if (parseInt(js_month) < 10)
			js_month = "0" + js_month;

		return js_year + "" +  js_month + "" + js_day;
	}

	JsCalendar.prototype.setValue = function(value)
	{
		js_day = value.substring(6,8);
		js_month = value.substring(4,6);
		js_year = value.substring(0,4);
		this.setDay(js_day);
		this.year = js_year;
		this.setMonth(js_month);

	}

	JsCalendar.prototype.setDay = function(value)
	{
		this.day = value;
	}

	JsCalendar.prototype.setMonth = function(value)
	{
		this.month = value - 1;
		this.monthcell.innerHTML = translation[lang]["month"][this.month] + " " + this.year;
		this.build();
	}

	JsCalendar.prototype.setYear = function(value)
	{
		this.year = value;
		this.monthcell.innerHTML = translation[lang]["month"][this.month] + " " + this.year;

		// array of total days in each month
		this.totalDays = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		// leap year correction
		if (this.year % 4 == 0)
			this.totalDays[1] = 29;

		this.build();
	}

	JsCalendar.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		for (js_i in this.childList)
			this.childList[js_i].setAttribute(name,value);
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsCalendar.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsCalendar.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		for (js_i in this.childList)
			this.childList[js_i].setEvent(eventStr,fnc);
	}

	JsCalendar.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");
		for (js_i in this.childList)
			this.childList[js_i].unsetEvent(eventStr,fnc);
	}

	JsCalendar.prototype.disableEvent = function(eventStr,fnc)
	{
		for (js_i in this.childList)
			this.childList[js_i].disableEvent(eventStr,fnc);
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsCalendar.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsCalendar.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsCalendar.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsCalendar.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsCalendar.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsCalendar.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsCalendar.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsCalendar.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsCalendar.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsCalendar.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	function changeMonth(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		targetObj = eval(obj.parent);

		var month = targetObj.month;
		var year = targetObj.year;

		if (obj.action == "increase")
		{
			month++;
			if (month == 12)
			{
				month = 0;
				year++;
			}
		}
		else
		{
			month--;
			if (month == -1)
			{
				month = 11;
				year--;;
			}
		}
		targetObj.month = month;
		targetObj.setYear(year);
	}

	function setCalendarItemOver(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		target_obj = eval(obj.parent);

		target_obj.setClass("calendarDayCellOver");
	}

	function setCalendarItemOut(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		target_obj = eval(obj.parent);

		target_obj.setClass("calendarDayCell");
	}

	function setCalValue(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		source_obj = eval(obj.parent);
		target_obj = eval(obj.parentObj);

		target_obj.setDay(source_obj.getValue());
	}
