
	//Model of jsobject. All should have at least those methods implemented
	JsCheckBox = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsCheckBox";
		this.menu				= null;
		this.parent				= null;
		
		//By default check has a boolean value of true
		//Is checked, returns true or its defined value, else returns false
		this.value				= true;

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.output.id			= this.id;
		this.output.className	= "lb";
		this.output.style.overflow = "hidden";
		
		//lay-out
		this.tab				= document.createElement("table");
		this.row				= this.tab.insertRow(this.tab.rows.length);
		this.checkcell			= this.row.insertCell(0);
		this.labelcell			= this.row.insertCell(1);

		//The checkbox itself
		this.check				= document.createElement("input");
		this.check.type			= "checkbox";
		this.check.id			= this.id + "_check";
		this.check.className	= "lbclick";

		//Checkbox label
		this.label				= document.createElement("label");
		this.label.htmlFor		= this.id + "_check";
		this.label.className	= "lbclick";
		this.label.appendChild(document.createTextNode(""));

		//put it all together
		this.checkcell.appendChild(this.check);
		this.labelcell.appendChild(this.label);
		this.output.appendChild(this.tab);
	}

	/********************************************
				  Exclusive Methods
	********************************************/

	JsCheckBox.prototype.setLabel = function(label)
	{
		this.labelcell.removeChild(this.label);
		this.label				= document.createElement("label");
		this.label.htmlFor		= this.id + "_check";
		this.label.className	= "lbclick";
		this.label.appendChild(document.createTextNode("  " + label));
		this.labelcell.appendChild(this.label);
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsCheckBox.prototype.getValue = function()
	{
		if (this.check.checked)
			return this.value;
		else
			return false;
	}

	JsCheckBox.prototype.setValue = function(value)
	{
		this.value = value;
		this.output.value = value;
		this.check.value = value;
		this.label.value = value;
	}

	JsCheckBox.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("this.check." + name + " = \"" + value + "\"");
		eval("this.label." + name + " = \"" + value + "\"");
	}
	
	JsCheckBox.prototype.setChecked = function(value)
	{
		if (value)
			this.check.checked = true;
		else
			this.check.checked = false;
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsCheckBox.prototype.setMenu = function(obj)
	{
		this.check.menu = obj;
		this.label.menu = obj;
		this.output.menu = obj;
	}

	JsCheckBox.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}");
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.check.attachEvent("on" + eventStr, fnc);
			this.label.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.check.addEventListener(eventStr, fnc, false);
			this.label.addEventListener(eventStr, fnc, false);
		}
	}

	JsCheckBox.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.check.detachEvent("on" + eventStr, fnc);
			this.label.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.check.removeEventListener(eventStr, fnc, false);
			this.label.removeEventListener(eventStr, fnc, false);
		}
	}

	JsCheckBox.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.check.detachEvent("on" + eventStr, fnc);
			this.label.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.check.removeEventListener(eventStr, fnc, false);
			this.label.removeEventListener(eventStr, fnc, false);
		}
	}

	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsCheckBox.prototype.setHeight = function(value)
	{
		this.output.style.height = value;
	}
	
	JsCheckBox.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
	}
	
	JsCheckBox.prototype.setClass = function(value)
	{
		this.check.className = value;
		this.label.className = value;
		this.output.className = value;
	}
	
	JsCheckBox.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value;
	}
	
	JsCheckBox.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value;
	}
	
	JsCheckBox.prototype.setFontColor = function(value)
	{
		this.output.style.color = value;
	}
	
	JsCheckBox.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value;
	}
	
	JsCheckBox.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value;
	}
	
	JsCheckBox.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value;
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsCheckBox.prototype.disable = function(value)
	{
		this.check.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j]);
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j]);
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

