
	//Model of jsobject. All should have at least those methods implemented
	JsComboBox = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsComboBox";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();
		this.value				= null;

		this.sortable			= true;

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");

		this.comboboxtab		= document.createElement("table");
		this.comboboxrow		= this.comboboxtab.insertRow(0);
		this.comboboxtxtcell	= this.comboboxrow.insertCell(0);
		this.comboboxbtcell		= this.comboboxrow.insertCell(1);
		this.comboboxtxt		= new JsLabel(this.name + "_lineedit");
		this.comboboxbt			= new JsImageButton(this.name + "_button");
		this.comboboxlist		= new JsListBox(this.name + "_listbox");

		this.comboboxtab.menu	= this.comboboxlist;
		this.comboboxrow.menu	= this.comboboxlist;
		this.comboboxtxtcell.menu	= this.comboboxlist;
		this.comboboxtxt.setMenu(this.comboboxlist);
		this.comboboxbt.setMenu(this.comboboxlist);

		this.comboboxtxt.setHeight(24);

		this.comboboxbt.setSource("images/combobuttonup.gif");

		this.comboboxtxtcell.appendChild(this.comboboxtxt.output);
		this.comboboxbtcell.appendChild(this.comboboxbt.output);

		this.output.className	= "lb";
		this.output.style.overflow = "hidden";

		this.comboboxlist.output.style.visibility = "hidden";
		this.comboboxlist.output.style.display = "none";

		this.comboboxtab.className = "combobox";
		this.comboboxtxt.setClass("comboboxtxt");
		this.comboboxtxtcell.className = "comboboxcell";
		this.comboboxbtcell.className = "comboboxbtcell";
		this.comboboxbtcell.style.width = "20";
		this.comboboxlist.setClass("comboboxlist");

		this.comboboxtxtcell.style.verticalAlign = "top";
		this.comboboxbtcell.style.verticalAlign = "top";

		this.comboboxbt.setEvent("mouseover",setComboBtOver);
		this.comboboxbt.setEvent("mouseout",setComboBtOut);
		this.comboboxbt.setEvent("click",setComboBtClick);

		this.comboboxtxt.setEvent("mouseover",setComboBtOver);
		this.comboboxtxt.setEvent("mouseout",setComboBtOut);
		this.comboboxtxt.setEvent("click",setComboBtClick);

		this.comboboxbt.setAttribute("parent",this.name);
		this.comboboxtxt.setAttribute("parent",this.name);
		this.comboboxlist.setAttribute("parent",this.name);

		this.output.appendChild(this.comboboxtab);
		document.body.appendChild(this.comboboxlist.output);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Content Methods
	********************************************/

	JsComboBox.prototype.addItem = function(value, label, icon, selected)
	{
		if (!label)
			label = value;

		this.comboboxlist.sortable = this.sortable;

		index = this.comboboxlist.addItem(value, label, icon, false);
		this.comboboxlist.childList[index].setEvent("click", setComboValue);
		this.comboboxlist.childList[index].setAttribute("comboparent", this.name);

		if (selected)
		{
			this.setValue(value);
			this.setLabel(label);
			if (icon)
			{
				this.setIcon(icon);
				this.comboboxtxt.setAttribute("parent",this.name);
				this.comboboxtxt.setMenu(this.comboboxlist);
			}
		}

		this.childList[index] = this.comboboxlist.childList[index];
	}
	
	JsComboBox.prototype.delItem = function(index)
	{
		this.comboboxlist.delItem(index)

		var index;
		var tempList = new Array();
		for (var js_i in this.childList)
		{
			if (js_i != index)
				tempList[tempList.length] = this.childList[js_i];
			else
				delete this.childList[js_i];
		}
		this.childList = new Array();
		this.childList = tempList;
		tempList = null;
	}

	/********************************************
				End of Content Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsComboBox.prototype.getValue = function()
	{
		return this.value;
	}

	JsComboBox.prototype.setValue = function(value)
	{
		var value;
		this.value = value;
		for (var js_i in this.comboboxlist.childList)
		{
			if (this.comboboxlist.childList[js_i].getValue() == value)
			{
				this.setLabel(this.comboboxlist.childList[js_i].label.value);
				if (this.comboboxlist.childList[js_i].label.icon)
					if (this.comboboxlist.childList[js_i].label.icon.src)
					{
						this.setIcon(this.comboboxlist.childList[js_i].label.icon.src);
						this.comboboxtxt.setAttribute("parent",this.name);
						this.comboboxtxt.setMenu(this.comboboxlist);
					}
			}
		}
	}

	JsComboBox.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("this.comboboxtab." + name + " = \"" + value + "\"");
		eval("this.comboboxtxtcell." + name + " = \"" + value + "\"");
		eval("this.comboboxbtcell." + name + " = \"" + value + "\"");
		this.comboboxlist.setAttribute(name,value);
		this.comboboxbt.setAttribute(name,value);
		this.comboboxtxt.setAttribute(name,value);
	}

	JsComboBox.prototype.setLabel = function(value)
	{
		this.comboboxtxt.setValue(value);
	}

	JsComboBox.prototype.setIcon = function(value)
	{
		this.comboboxtxt.setIcon(value);
	}

	/********************************************
				End of Values Methods
	********************************************/

	/********************************************
				   Events Methods
	********************************************/

	JsComboBox.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}

	JsComboBox.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}");
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (eventStr != "change")
		{
			if (browserType == "ie")
			{
				this.output.attachEvent("on" + eventStr, fnc);
			}
			else
			{
				this.output.addEventListener(eventStr, fnc, false);
			}

			this.comboboxlist.setEvent(eventStr,fnc);
		}
	}

	JsComboBox.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"']splice.(js_i);}}");

		if (eventStr != "change")
		{
			if (browserType == "ie")
			{
				this.combobox.detachEvent("on" + eventStr, fnc);
			}
			else
			{
				this.combobox.removeEventListener(eventStr, fnc, false);
			}
		}
	}

	JsComboBox.prototype.disableEvent = function(eventStr,fnc)
	{
		if (eventStr != "change")
		{
			if (browserType == "ie")
			{
				this.combobox.detachEvent("on" + eventStr, fnc);
			}
			else
			{
				this.combobox.removeEventListener(eventStr, fnc, false);
			}
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/

	JsComboBox.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
	}

	JsComboBox.prototype.setClass = function(value)
	{
		this.output.className = value;
	}

	/********************************************
				End of Visual Methods
	********************************************/

	/********************************************
				  General Methods
	********************************************/
	
	JsComboBox.prototype.disable = function(value)
	{
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent([js_i],this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent([js_i],this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
			  External Functions
	********************************************/

	function setComboBtOver(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		//e.cancelBubble = true;
		target_obj = eval(obj.parent);
		target_obj.comboboxbt.setSource("images/combobuttonover.gif");
	}

	function setComboBtOut(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		//e.cancelBubble = true;
		target_obj = eval(obj.parent);
		target_obj.comboboxbt.setSource("images/combobuttonup.gif");
	}

	function setComboBtClick(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		target_obj = eval(obj.parent);
		comboLeft = getObjLeft(obj, target_obj.output);
		target_obj.comboboxbt.setSource("images/combobuttondown.gif");
		if (browserType == "ie")
 		{
			//I HATE INTERNET EXPLORER!!! A lot of workarounds coming next, just because of them!!!
			magicY = -3;
			magicX = 0;
			if (obj == target_obj.comboboxtxt.labelcell)
				magicX = 4;
			else if (obj == target_obj.comboboxbt.button)
				magicX = -2;
			else
			{
				magicX = -3
				magicY = -4;
			}
			target_obj.comboboxlist.output.style.top = (e.clientY - e.offsetY) - ((target_obj.output.offsetHeight - obj.offsetHeight)/2) + target_obj.output.offsetHeight + magicY + document.body.scrollTop;
			target_obj.comboboxlist.output.style.left = (e.clientX - e.offsetX) - comboLeft + magicX + document.body.scrollLeft
			target_obj.comboboxlist.output.style.width = target_obj.output.offsetWidth - 22;
		}
		else
		{
			target_obj.comboboxlist.output.style.top = e.clientY - e.layerY + 23 + document.body.scrollTop;
			target_obj.comboboxlist.output.style.left = e.clientX - e.layerX + document.body.scrollLeft;
			target_obj.comboboxlist.output.style.width = target_obj.output.offsetWidth - 24;
		}
		target_obj.output.style.zIndex = 100000;
		target_obj.comboboxlist.output.style.zIndex = 100000;
		if (top.activehidden && target_obj.comboboxlist != top.activehidden)
		{
			if (top.activehidden.type == "JsMenu")
				hideParentsMenus(top.activehidden);
			else
			{
				top.activehidden.output.style.visibility = "hidden";
				top.activehidden.output.style.display = "none";
			}
		}
		target_obj.comboboxlist.output.style.visibility = "visible";
		target_obj.comboboxlist.output.style.display = "block";

		top.activehidden = target_obj.comboboxlist;

		document.onclick = hideActiveHidden;
		top.showmenus = false;
	}

	function setComboValue(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		var js_comboitem = eval(obj.parent);
		var js_combolist = js_comboitem.parent;
		var js_combo = eval(obj.comboparent);

		js_combolist.resetSelecteds();
		setListBoxItemSelected(e)

		var old_value = js_combo.getValue();
		var new_value = js_combolist.getValue()[0][0];

		js_combo.setValue(new_value);

		js_combolist.resetSelecteds();

		if (old_value != new_value)
		{
			for (var js_i in js_combo.events['change'])
				js_combo.events['change'][js_i](e);
		}
	}
