
	//Model of jsobject. All should have at least those methods implemented
	JsDialog = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsDialog";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.dialogtab			= document.createElement("table");
		this.dialogtab.className = "dialog";

		this.toprow				= this.dialogtab.insertRow(this.dialogtab.rows.length);
		this.topleftcell		= this.toprow.insertCell(this.toprow.cells.length);
		this.topcentercell		= this.toprow.insertCell(this.toprow.cells.length);
		this.toprightcell		= this.toprow.insertCell(this.toprow.cells.length);

		this.topleftcell.style.width = "24";
		this.topleftcell.style.height = "17";
		this.toprightcell.style.width = "24";
		this.toprightcell.style.height = "17";

		if (browserType=="ie")
		{
			this.topleftcell.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/top_left_corner.png')";
			this.topcentercell.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/top_center.png',sizingMethod='scale')";
			this.toprightcell.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/top_right_corner.png')";
		}
		else
		{
			this.topleftcell.style.backgroundImage = "url('images/top_left_corner.png')";
			this.topcentercell.style.backgroundImage = "url('images/top_center.png')";
			this.toprightcell.style.backgroundImage = "url('images/top_right_corner.png')";
		}

		this.topleftcell.innerHTML = "&nbsp;";
		this.topcentercell.innerHTML = "&nbsp;";
		this.toprightcell.innerHTML = "&nbsp;";

		this.dialogrow			= this.dialogtab.insertRow(this.dialogtab.rows.length);
		this.middleleftcell		= this.dialogrow.insertCell(this.dialogrow.cells.length);
		this.dialogcell			= this.dialogrow.insertCell(this.dialogrow.cells.length);
		this.middlerightcell	= this.dialogrow.insertCell(this.dialogrow.cells.length);

		this.middleleftcell.style.width = "24";
		this.middlerightcell.style.width = "24";

		if (browserType=="ie")
		{
			this.middleleftcell.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/left_center.png',sizingMethod='scale')";
			this.middlerightcell.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/right_center.png',sizingMethod='scale')";
		}
		else
		{
			this.middleleftcell.style.backgroundImage = "url('images/left_center.png')";
			this.middlerightcell.style.backgroundImage = "url('images/right_center.png')";
		}

		this.middleleftcell.innerHTML = "&nbsp;";
		this.middlerightcell.innerHTML = "&nbsp;";

		this.bottomrow			= this.dialogtab.insertRow(this.dialogtab.rows.length);
		this.bottomleftcell		= this.bottomrow.insertCell(this.bottomrow.cells.length);
		this.bottomcentercell	= this.bottomrow.insertCell(this.bottomrow.cells.length);
		this.bottomrightcell	= this.bottomrow.insertCell(this.bottomrow.cells.length);

		this.bottomleftcell.style.width = "24";
		this.bottomleftcell.style.height = "24";
		this.bottomrightcell.style.width = "24";
		this.bottomrightcell.style.height = "24";

		if (browserType=="ie")
		{
			this.bottomleftcell.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/bottom_left_corner.png')";
			this.bottomcentercell.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/bottom_center.png',sizingMethod='scale')";
			this.bottomrightcell.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/bottom_right_corner.png')";
		}
		else
		{
			this.bottomleftcell.style.backgroundImage = "url('images/bottom_left_corner.png')";
			this.bottomcentercell.style.backgroundImage = "url('images/bottom_center.png')";
			this.bottomrightcell.style.backgroundImage = "url('images/bottom_right_corner.png')";
		}

		this.bottomleftcell.innerHTML = "&nbsp;";
		this.bottomcentercell.innerHTML = "&nbsp;";
		this.bottomrightcell.innerHTML = "&nbsp;";

		this.dialogcell.style.backgroundColor = "#FFFFFF";

		this.output.appendChild(this.dialogtab)
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Content Methods
	********************************************/
	
	JsDialog.prototype.addItem = function(obj)
	{
		this.childList[this.childList.length] = obj;
		obj.parent = this;
		this.dialogcell.appendChild(obj.output);
	}

	JsDialog.prototype.delItem = function(obj)
	{
	}

	JsDialog.prototype.setItem = function(obj)
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsDialog.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsDialog.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}");
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsDialog.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsDialog.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsDialog.prototype.setHeight = function(value)
	{
		this.output.style.height = value;
	}
	
	JsDialog.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
	}
	
	JsDialog.prototype.setClass = function(value)
	{
		this.output.className = value;
	}
	
	JsDialog.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value;
	}
	
	JsDialog.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value;
	}
	
	JsDialog.prototype.setFontColor = function(value)
	{
		this.output.style.color = value;
	}
	
	JsDialog.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value;
	}
	
	JsDialog.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value;
	}
	
	JsDialog.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value;
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsDialog.prototype.disable = function(value)
	{
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j]);
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j]);
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/
