
	function JsLabel(name)
	{
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsLabel";
		this.parent				= null;
		this.menu				= null;
		this.value				= null;

		this.donthideMenu		= false;

		//JsObject events
		this.events				= new Array();

		//label main container
		this.output				= document.createElement("div");
		this.output.className	= "lb";
		this.output.style.overflow = "hidden";
		this.output.style.width = "100%";
		this.output.style.height = "100%";

		this.labeltab			= document.createElement("table");
		this.labeltab.style.height = 22;
		this.labeltab.style.width = "100%";
		//this.labeltab.style.border = "1px solid #000000";

		this.labelrow			= this.labeltab.insertRow(this.labeltab.rows.length);
		this.labelcell			= this.labelrow.insertCell(0);

		this.output.appendChild(this.labeltab);

		this.setAttribute("parentObj",this.name);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsLabel.prototype.setIcon = function (icon, align)
	{
		if (!this.iconcell)
		{
			this.icon = document.createElement("img");
			if (align == "right")
				var index = this.labelrow.cells.length;
			else
				var index = this.labelrow.cells.length - 1;
			this.iconcell = this.labelrow.insertCell(index);
			this.iconcell.style.width = "20";
			this.iconcell.appendChild(this.icon);
			
			for (js_i in this.events)
			{
				for (js_j in this.events[js_i])
				{
					if (browserType == "ie")
						this.output.attachEvent("on" + this.events[js_i], this.events[js_i][js_j]);
					else
						this.output.addEventListener(this.events[js_i], this.events[js_i][js_j], false);
				}
			}
		}
		this.icon.src = icon;
	}

	JsLabel.prototype.setEditable = function()
	{
		this.setEvent("dblclick",editDblClick);
	}
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsLabel.prototype.getValue = function()
	{
		return this.value;
	}

	JsLabel.prototype.setValue = function (value)
	{
		this.value = value;
		this.labelcell.innerHTML = value;
	}

	JsLabel.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("this.labeltab." + name + " = \"" + value + "\"");
		eval("this.labelrow." + name + " = \"" + value + "\"");
		eval("this.labelcell." + name + " = \"" + value + "\"");
		if (this.iconcell)
		{
			eval("this.icon." + name + " = \"" + value + "\"");
			eval("this.iconcell." + name + " = \"" + value + "\"");
		}
	}

	/********************************************
				End of Values Methods
	********************************************/

	/********************************************
				   Events Methods
	********************************************/
	
	JsLabel.prototype.setMenu = function(obj)
	{
		this.output.menu = obj;
		this.labeltab.menu = obj;
		this.labelrow.menu = obj;
		this.labelcell.menu = obj;
		if (this.iconcell)
		{
			this.iconcell.menu = obj;
			this.icon.menu = obj;
		}
	}

	JsLabel.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}");
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsLabel.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsLabel.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsLabel.prototype.setHeight = function(value)
	{
		this.output.style.height = value;
		this.labeltab.style.height = value;
	}

	JsLabel.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
		this.labeltab.style.width = value;
	}

	JsLabel.prototype.setClass = function(value)
	{
		this.labeltab.className = value;
	}
	
	JsLabel.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value;
	}
	
	JsLabel.prototype.setFont = function(value)
	{
		this.labelcell.style.fontFamily = value;
	}
	
	JsLabel.prototype.setFontColor = function(value)
	{
		this.labelcell.style.color = value;
	}
	
	JsLabel.prototype.setFontSize = function(value)
	{
		this.labelcell.style.fontSize = value;
	}

	JsLabel.prototype.setFontWeight = function(value)
	{
		this.labelcell.style.fontWeight = value;
	}
	
	JsLabel.prototype.setFontItalic = function(value)
	{
		this.labelcell.style.fontStyle = value;
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsLabel.prototype.disable = function(value)
	{
		this.output.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j]);
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent([js_i],this.events[js_i][js_j]);
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
			Convert a label into a lineedit
				Useful for ListViews
	********************************************/
	function editDblClick(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		sourceObj = eval(obj.parentObj);
		rnd = randomizer();
		eval(rnd + "edit		= new JsLineEdit('" + rnd + "day')");
		tempObj = eval(rnd + "edit");
		tempObj.setValue(sourceObj.getValue());
		if (sourceObj.output.lstitemparent)
			tempObj.setAttribute("lstitemparent",sourceObj.output.lstitemparent);
		tempObj.setAttribute("targetObj",obj.parentObj);
		tempObj.setAttribute("parentObj",rnd + "edit");
		tempObj.setEvent("blur",endeditDblClick);
		tempObj.setEvent("keypress",endeditDblClick);

		sourceObj.output.parentNode.appendChild(tempObj.output);
		sourceObj.output.parentNode.removeChild(sourceObj.output);

		tempObj.lineedit.focus();
		tempObj.lineedit.select();
	}

	/********************************************
			Convert a lineedit into a label
				Useful for ListViews
	********************************************/
	function endeditDblClick(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		targetObj = eval(obj.targetObj);
		sourceObj = eval(obj.parentObj);

		if ((e.keyCode == 13 || e.keyCode == 9) || e.type=="blur")
		{
			targetObj.setValue(sourceObj.getValue());
			sourceObj.output.parentNode.appendChild(targetObj.output);
			sourceObj.output.parentNode.removeChild(sourceObj.output);
		}

		sourceObj = null;
	}
