
	//Model of jsobject. All should have at least those methods implemented
	JsLineEdit = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsLineEdit";
		this.menu				= null;
		this.parent				= null;

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");

		this.table				= document.createElement("table");
		this.row				= this.table.insertRow(0);
		this.cell				= this.row.insertCell(0);
		this.table.className	= "lineedittable";
		this.cell.className		= "lineeditcell";

		this.lineedit			= document.createElement("input");
		this.lineedit.type		= "text";
		this.lineedit.className	= "lineedit";
		this.setEvent("focus",enableSelection);
		this.setEvent("mouseover",enableSelection);
		this.setEvent("blur",disableSelection);
		this.setEvent("mouseout",disableSelection);

		this.cell.appendChild(this.lineedit);
		this.output.appendChild(this.table);

		this.setEvent("keypress", setHasChanges);
	}

	/********************************************
				  Exclusive Methods
	********************************************/

	JsLineEdit.prototype.setPassword = function()
	{
		this.cell.removeChild(this.lineedit)
		this.lineedit			= document.createElement("input");
		this.lineedit.type		= "password";
		this.lineedit.className	= "lineedit";
		this.setEvent("focus",enableSelection);
		this.setEvent("mouseover",enableSelection);
		this.setEvent("blur",disableSelection);
		this.setEvent("mouseout",disableSelection);
		this.cell.appendChild(this.lineedit);
	}

	JsLineEdit.prototype.setNumeric = function()
	{
		this.setEvent("keypress",checkNumeric);
	}
	
	JsLineEdit.prototype.setChar = function()
	{
		this.unsetEvent("keypress",checkNumeric);
	}

	JsLineEdit.prototype.setMaxLength = function(value)
	{
		this.lineedit.maxLength = value;
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsLineEdit.prototype.getValue = function()
	{
		this.value = this.lineedit.value;
		return this.value;
	}

	JsLineEdit.prototype.setValue = function(value)
	{
		this.value = value;
		this.lineedit.value = value;
	}

	JsLineEdit.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("this.lineedit." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsLineEdit.prototype.setMenu = function(obj)
	{
		this.output.menu = obj;
		this.lineedit.menu = obj;
	}
	
	JsLineEdit.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}");
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			//this.output.attachEvent("on" + eventStr, fnc);
			this.lineedit.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			//this.output.addEventListener(eventStr, fnc, false);
			this.lineedit.addEventListener(eventStr, fnc, false);
		}
	}

	JsLineEdit.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			//this.output.detachEvent("on" + eventStr, fnc);
			this.lineedit.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			//this.output.removeEventListener(eventStr, fnc, false);
			this.lineedit.removeEventListener(eventStr, fnc, false);
		}
	}

	JsLineEdit.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			//this.output.detachEvent("on" + eventStr, fnc);
			this.lineedit.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			//this.output.removeEventListener(eventStr, fnc, false);
			this.lineedit.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/

	JsLineEdit.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
		this.cell.style.width = value;
	}

	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsLineEdit.prototype.disable = function(value)
	{
		this.lineedit.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j]);
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j]);
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	function checkNumeric(e)
	{
		var numbers = '01234567890';

		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
			e.cancelBubble = true;
			if ((numbers.search(String.fromCharCode(e.keyCode))==-1))
				e.returnValue = false;
		}
		else
		{
			obj = e.target;
			e.cancelBubble = true;
			if ((numbers.search(String.fromCharCode(e.charCode))==-1) && checkUsedKeys(e.keyCode))
				e.preventDefault();
		}
	}

	function checkUsedKeys (value)
	{
		if (value == 8 || value == 9 || value == 13 || value == 18 || value == 35 || value == 36 || value == 37 || value == 38 || value == 39|| value == 40  || value == 45  || value == 46)
			return false;
		return true
	}
