
	//Model of jsobject. All should have at least those methods implemented
	JsLineEditAdv = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsLineEditAdv";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();
		
		this.value				= null;
		
		//minimum length to perform a search
		this.minsearchlength	= 5;

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");
		
		this.lineedit			= eval(this.name + "lineedit = new JsLineEdit('" +this.name + "lineedit')");
		this.dc					= eval(this.name + "dataconnector = new JsDataConnector('" +this.name + "dataconnector')");
		this.listbox			= eval(this.name + "listbox = new JsListBox('" +this.name + "listbox')");
		
		this.lineedit.setEvent("keyup",ladvGetData);
		this.lineedit.setEvent("keyup",ladvChooseItem);
		
		this.lineedit.setAttribute("obj_parent",this.name);
		
		this.output.appendChild(this.lineedit.output);
		
		if(browserType=="ie")
			document.body.appendChild(this.listbox.output);
		else
			this.output.appendChild(this.listbox.output);
			
		this.listbox.setAttribute("parent",this.name);			
		this.listbox.output.style.visibility = "hidden";
		this.listbox.output.style.display = "none";
		this.listbox.setClass("comboboxlist");
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsLineEditAdv.prototype.setMinSearchLength = function(value)
	{
		this.minsearchlength = value;
	}
	
	JsLineEditAdv.prototype.setHandler = function(value)
	{
		this.dc.setHandler(value);
	}
	
	//Add an item to a listbox. If item is of type listboxitem, its added as a child;
	//If you wish to add a listboxitem, use the method as bellow
	JsLineEditAdv.prototype.addItem = function(js_listviewitem_obj){}
	//If you wish to add plain text, use the method as bellow
	JsLineEditAdv.prototype.addItem = function(your_value, your_label, your_icon, is_selected){}
	
	JsLineEditAdv.prototype.addItem = function()
	{
		index = this.listbox.addItem(arguments[0],arguments[1],arguments[2],arguments[3]);
		this.listbox.childList[index].setEvent("click", ladvChooseItemClick);
		this.listbox.childList[index].setAttribute("leadvparent", this.name);
	}
	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsLineEditAdv.prototype.getValue = function()
	{
		js_arr = new Array();
		js_arr[0] = this.value;
		js_arr[1] = this.lineedit.getValue();
		return js_arr;
	}
	
	JsLineEditAdv.prototype.setValue = function(value,label)
	{
		this.value = value;
		this.lineedit.setValue(label);
	}

	JsLineEditAdv.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		this.lineedit.setAttribute(name,value);
		this.listbox.setAttribute(name,value);
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsLineEditAdv.prototype.setMenu = function(obj)
	{
		this.output.menu = obj;
		this.lineedit.setMenu(obj);
	}
	
	JsLineEditAdv.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");
		
		this.lineedit.setEvent(eventStr,fnc);

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsLineEditAdv.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");
		
		this.lineedit.unsetEvent(eventStr,fnc);

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsLineEditAdv.prototype.disableEvent = function(eventStr,fnc)
	{
		this.lineedit.disableEvent(eventStr,fnc);
		
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsLineEditAdv.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsLineEditAdv.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsLineEditAdv.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsLineEditAdv.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsLineEditAdv.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsLineEditAdv.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsLineEditAdv.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsLineEditAdv.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsLineEditAdv.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsLineEditAdv.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
			  	  External Methods
	********************************************/
	
	function ladvGetData(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		
		leadv = eval(obj.obj_parent);
		
		if (e.keyCode==37 || e.keyCode==38 || e.keyCode==39 || e.keyCode==40 || e.keyCode==13)
			return false;
			
		leadv.value = null;
		
		if (obj.value.length >= leadv.minsearchlength)
		{
			leadv.listbox.clearData();
			//sets's the name of the line edit advanced object instance so the handler knows
			//which object on the parent level should receive the list itens
			leadv.dc.setFieldValue("leadv_name",leadv.name);
			leadv.dc.setFieldValue("searchkey",obj.value);
			leadv.dc.postData();
			
			lineadvLeft = getObjLeft(obj, leadv.output);
			if (browserType == "ie")
			{				
				leadv.listbox.output.style.top = (e.clientY - e.offsetY) + 16 + document.body.scrollTop;
				leadv.listbox.output.style.left = (e.clientX - e.offsetX) - 6 + document.body.scrollLeft
				leadv.listbox.output.style.width = leadv.output.offsetWidth;
			}
			else
			{
				leadv.listbox.output.style.width = leadv.output.offsetWidth - 2;
			}

			leadv.output.style.zIndex = 100000;
			leadv.listbox.output.style.zIndex = 100000;
			
			if (top.activehidden && leadv.listbox != top.activehidden)
			{
				if (top.activehidden.type == "JsMenu")
					hideParentsMenus(top.activehidden);
				else
				{
					top.activehidden.output.style.visibility = "hidden";
					top.activehidden.output.style.display = "none";
				}
			}
			leadv.listbox.output.style.visibility = "visible";
			leadv.listbox.output.style.display = "block";
	
			top.activehidden = leadv.listbox;
	
			document.onclick = hideActiveHidden;
			top.showmenus = false;
		}
		else
		{
			leadv.listbox.clearData();
			leadv.listbox.output.style.visibility = "hidden";
			leadv.listbox.output.style.display = "none";
		}
	}
	
	function ladvChooseItem(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		
		leadv = eval(obj.obj_parent);
		
		if (e.keyCode==13)
		{
			selectedItem = leadv.listbox.getValue();
			leadv.setValue(selectedItem[0][0],selectedItem[0][1]);
			leadv.listbox.output.style.visibility="hidden";
			leadv.listbox.resetSelecteds();
		}
		if (e.keyCode==40 || e.keyCode==38)
		{
			selIndex = -1;
			for (var js_i in leadv.listbox.childList)
			{
				if (leadv.listbox.childList[js_i].selected)
				{
					selIndex = js_i;
					break;
				}
			}
			if (e.keyCode==40)
				selIndex = parseInt(selIndex) + 1;
			else
				selIndex = parseInt(selIndex) -1;

			if (selIndex < leadv.listbox.childList.length && selIndex > -1)
			{
				leadv.listbox.resetSelecteds();
				leadv.listbox.setItemSelected(selIndex,true);
				
				if (selIndex>3 && e.keyCode==40)
					leadv.listbox.output.scrollTop = leadv.listbox.output.scrollTop + 24;
				else if (leadv.listbox.output.scrollTop > 0)
					leadv.listbox.output.scrollTop = leadv.listbox.output.scrollTop - 24;
			}
		}
	}
	
	function ladvChooseItemClick(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		var leadv = eval(obj.leadvparent);
		
		leadv.listbox.resetSelecteds();
		setListBoxItemSelected(e)
		
		selectedItem = leadv.listbox.getValue();
		leadv.setValue(selectedItem[0][0],selectedItem[0][1]);
		leadv.listbox.output.style.visibility="hidden";
		leadv.listbox.resetSelecteds();
	}
	
	/********************************************
			  End of External Methods
	********************************************/