
	//Model of jsobject. All should have at least those methods implemented
	JsListBox = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsListBox";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();
		this.value				= new Array();

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");
		this.output.className	= "listbox";

		this.sortable			= true;
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	//empties the Listbox itens
	JsListBox.prototype.clearData = function()
	{
		for (i in this.childList)
			this.output.removeChild(this.childList[i].output);
		this.childList			= new Array();
		this.value				= new Array();
		this.output.scrollTop	= 0;
	}
	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Content Methods
	********************************************/
	
	//Add an item to a listbox. If item is of type listboxitem, its added as a child;
	//If you wish to add a listboxitem, use the method as bellow
	JsListBox.prototype.addItem = function(js_listviewitem_obj){}
	//If you wish to add plain text, use the method as bellow
	JsListBox.prototype.addItem = function(your_value, your_label, your_icon, is_selected){}

	JsListBox.prototype.addItem = function()
	{
		var index = this.childList.length;

		if (arguments[0]!=0)
			if (!arguments[0])
			{
    			alert("You must at least specify the item value!");
				return false;
			}

		if (arguments[0].type == "JsListBoxItem")
			this.childList[index] = arguments[0];
		else
		{
			obj_name = randomizer();
			eval(obj_name + " = new JsListBoxItem(\"" + obj_name + "\")");
			this.childList[index] = eval(obj_name);
			this.childList[index].setValue(arguments[0]);
			if (arguments[1])
				this.childList[index].setLabel(arguments[1]);
			if (arguments[2])
				this.childList[index].setIcon(arguments[2]);
			if (arguments[3])
				this.childList[index].setSelected();
		}

		if (this.output.donthidemenu)
			this.childList[index].setAttribute("donthidemenu","true");
		this.childList[index].parent = this;

		this.output.appendChild(this.childList[index].output);

		if (this.sortable)
		{
			this.childList.sort(sortJsListBox);

			for (js_i in this.childList)
			{
				this.output.appendChild(this.childList[js_i].output);
				if (this.childList[js_i].getValue() == arguments[0] && this.childList[js_i].label.getValue() == arguments[1])
					index = js_i;
			}
		}

		return index;
	}

	JsListBox.prototype.delItem = function(index)
	{
		var index;
		var tempList = new Array();
		for (var js_i in this.childList)
		{
			if (js_i != index)
				tempList[tempList.length] = this.childList[js_i];
			else
			{
				this.childList[js_i].output.parentNode.removeChild(this.childList[js_i].output);
				delete this.childList[js_i];
			}
		}
		this.childList = new Array();
		this.childList = tempList;
		tempList = null;
	}
	
	JsListBox.prototype.setItem = function(index, value, label, icon, selected)
	{
		this.childList[index].setValue(value);
		this.childList[index].setLabel(label);
		this.childList[index].setIcon(icon);
		this.childList[index].setSelected(selected);
	}
	
	JsListBox.prototype.setItemSelected = function(index, selected)
	{
		this.childList[index].setSelected(selected);
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsListBox.prototype.getValue = function()
	{
		this.value = new Array();
		for (var js_i in this.childList)
			if (this.childList[js_i].selected)
			{
				index = this.value.length
				this.value[index] = new Array();
				this.value[index][0] = this.childList[js_i].getValue();
				this.value[index][1] = this.childList[js_i].label.getValue();
			}
		return this.value;
	}

	JsListBox.prototype.getAllValues = function()
	{
		this.value = new Array();
		for (var js_i in this.childList)
		{
			index = this.value.length
			this.value[index] = new Array();
			this.value[index][0] = this.childList[js_i].getValue();
			this.value[index][1] = this.childList[js_i].label.getValue();
			if (this.childList[js_i].label.icon)
				this.value[index][2] = this.childList[js_i].label.icon.src;
			else
				this.value[index][2] = null;
		}
		return this.value;
	}
	
	JsListBox.prototype.setValue = function()
	{
	}

	JsListBox.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("for (var js_i in this.childList){this.childList[js_i].setAttribute('" + name + "','" + value + "')}")
	}

	JsListBox.prototype.resetSelecteds = function()
	{
		for (var js_i in this.childList)
		{
			this.childList[js_i].selected = false;
			this.childList[js_i].setClass("listboxitem");
		}
	}

	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsListBox.prototype.setMenu = function(obj)
	{
		this.output.menu = obj;
	}
	
	JsListBox.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}");
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsListBox.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsListBox.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsListBox.prototype.setHeight = function(value)
	{
		this.output.style.height = value;
	}
	
	JsListBox.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
	}
	
	JsListBox.prototype.setClass = function(value)
	{
		this.output.className = value;
	}
	
	JsListBox.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value;
	}
	
	JsListBox.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value;
	}
	
	JsListBox.prototype.setFontColor = function(value)
	{
		this.output.style.color = value;
	}
	
	JsListBox.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value;
	}
	
	JsListBox.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value;
	}
	
	JsListBox.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value;
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsListBox.prototype.disable = function(value)
	{
		this.listbox.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j]);
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j]);
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
			  	External Functions
	********************************************/

	function sortJsListBox(a,b)
	{
		if (a.label.getValue() > b.label.getValue())
			return 1;
		if (a.label.getValue() < b.label.getValue())
			return -1;
		return 0;
	}
