
	//Model of jsobject. All should have at least those methods implemented
	JsListBoxItem = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsListBoxItem";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();
		this.value				= "";
		this.selected			= false;

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.output.style.height = 24;
		this.label				= new JsLabel();
		this.label.setHeight(24);

		this.output.parent = this.name;
		this.label.setAttribute("parent",this.name);

		this.output.appendChild(this.label.output);

		this.label.setEvent("mouseover",setListBoxItemOver);
		this.label.setEvent("mouseout",setListBoxItemOut);
		this.label.setEvent("click",setListBoxItemSelected);
		this.label.setEvent("click",hideActiveHidden);
		this.label.setClass("listboxitem");
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsListBoxItem.prototype.setIcon = function(value)
	{
		this.label.setIcon(value);
		this.label.setAttribute("parent",this.name);
	}

	JsListBoxItem.prototype.setSelected = function(value)
	{
		if (value)
			this.selected = value;
		else
		{
			if (this.selected)
				this.selected = false;
			else
				this.selected = true;
		}

		if (this.selected)
			this.setClass("listboxitemselected");
		else
			this.setClass("listboxitem");
	}
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsListBoxItem.prototype.setValue = function(value)
	{
		this.value = value;
		this.label.setValue(value);
	}

	JsListBoxItem.prototype.setLabel = function(value)
	{
		this.label.setValue(value);
	}

	JsListBoxItem.prototype.getValue = function(value)
	{
		return this.value;
	}

	JsListBoxItem.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("this.label.setAttribute(\"" + name + "\",\"" + value + "\")");
	}

	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsListBoxItem.prototype.setMenu = function()
	{
	}
	
	JsListBoxItem.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}

		this.label.setEvent(eventStr, fnc);
	}

	JsListBoxItem.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsListBoxItem.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsListBoxItem.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}

	JsListBoxItem.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsListBoxItem.prototype.setClass = function(value)
	{
		this.label.setClass(value);
	}
	
	JsListBoxItem.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsListBoxItem.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsListBoxItem.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsListBoxItem.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsListBoxItem.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsListBoxItem.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsListBoxItem.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
				External Functions
	********************************************/
	function setListBoxItemOver(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		target_obj = eval(obj.parent);
		if (target_obj.selected)
			target_obj.setClass("listboxitemoverselected" + browserType);
		else
			target_obj.setClass("listboxitemover");
	}

	function setListBoxItemOut(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		target_obj = eval(obj.parent);
		if (target_obj.selected)
			target_obj.setClass("listboxitemselected");
		else
			target_obj.setClass("listboxitem");
	}

	function setListBoxItemSelected(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		target_obj = eval(obj.parent);
		target_obj.setSelected();
	}
