
	//Model of jsobject. All should have at least those methods implemented
	JsMenu = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsMenu";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();
		this.value				= "";
		this.width				= 0;
		this.height				= 0;
		this.contextmenu		= true;

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.output.className	= "menu";
		this.output.style.overflow = "hidden";
		this.output.style.visibility = "hidden";

		this.label = new JsMenuItem();

		this.label.setAttribute("submenuparent", this.name);

		document.body.appendChild(this.output);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsMenu.prototype.addDiv = function()
	{
		this.output.appendChild(document.createElement("hr"));
	}

	JsMenu.prototype.setIcon = function(value)
	{
		this.label.setIcon(value);
	}
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Content Methods
	********************************************/
	
	JsMenu.prototype.addItem = function(obj)
	{
		this.childList[this.childList.length] = obj;
		obj.parent = this;
		obj.contextmenu = this.contextmenu;
		if (obj.type == "JsMenu")
		{
			obj.label.setEvent("mouseover",showSubMenu);
			obj.label.setMenu(obj);
			obj.label.setAsSubMenu();

			obj.contextmenu = this.contextmenu;
			this.output.appendChild(obj.label.output);
		}
		else
		{
			this.output.appendChild(obj.output);
			if (obj.type == "JsMenuItem")
			{
				obj.setAttribute("parentObj",this.name);
				obj.setAttribute("parent",this.name);
				obj.setEvent("mouseover",hideActiveSubMenu);
			}
			else
				obj.setAttribute("donthidemenu","true");
		}

		if (obj.type == "JsMenu")
			totalwidth = obj.label.output.offsetWidth;
		else
			totalwidth = obj.output.offsetWidth;

		if (totalwidth > this.width)
			this.width = totalwidth;
		
		for (var js_i in this.childList)
		{
			if (this.childList[js_i].type == "JsMenu")
				this.childList[js_i].label.setWidth(this.width);
			else
				this.childList[js_i].setWidth(this.width);
		}

		if (obj.type == "JsMenu")
			this.height += obj.label.output.offsetHeight;
		else
			this.height += obj.output.offsetHeight;

		this.output.style.height = this.height;
	}
	
	JsMenu.prototype.delItem = function()
	{
	}

	JsMenu.prototype.setItem = function()
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsMenu.prototype.setValue = function(value)
	{
		this.value = value;
		this.label.setValue(value);
	}

	JsMenu.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
	}
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/

	JsMenu.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsMenu.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsMenu.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsMenu.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsMenu.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsMenu.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsMenu.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsMenu.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsMenu.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsMenu.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsMenu.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsMenu.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsMenu.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
				External Functions
	********************************************/

	/********************************************
	       General functions for bar menus
	********************************************/
	function setMenuBarItemOver(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		obj.className = "menubaritemover";

		if (top.showmenus)
		{
			showBarMenu(e);
		}
	}

	function setMenuBarItemOut(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		obj.className = "menubaritem";
	}

	function showBarMenu(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		if (browserType == "kq")
			menutop = (getObjTop(obj)/2) + obj.offsetHeight + 35;
		else
			menutop = (getObjTop(obj)/2) + obj.offsetHeight + 1;

		menuleft = getObjLeft(obj);

		showMenu(obj,menutop,menuleft);

		document.onclick = hideActiveHidden;
		top.activehidden = obj.menu;
		top.showmenus = true;
	}

	/********************************************
	    General functions for context menus
	********************************************/

	function showContextMenu(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		if (obj.menu)
		{
			menutop = e.clientY + document.body.scrollTop;
			menuleft = e.clientX + document.body.scrollLeft;

			if ((menutop + obj.menu.height) > parseInt(document.body.clientHeight))
				menutop =  e.clientY - obj.menu.height  + document.body.scrollTop;

			if ((menuleft + obj.menu.width) > parseInt(document.body.clientWidth))
				menuleft = e.clientX - obj.menu.width + document.body.scrollLeft;

			if (obj.menu)
				showMenu(obj,menutop,menuleft);

			document.onclick = hideActiveHidden;
			top.activehidden = obj.menu;
			top.showmenus = false;
		}
	}

	/********************************************
	       General functions for sub menus
	********************************************/
	function showSubMenu(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		submenuparent = eval(obj.submenuparent);

		if (browserType == "ie")
		{
			menutop = e.y - e.offsetY - obj.offsetTop - 3;
			menuleft = e.x - e.offsetX - obj.offsetLeft + submenuparent.parent.output.offsetWidth - 4;

			if ((menutop + submenuparent.height) > parseInt(document.body.clientHeight))
				menutop = e.y - e.offsetY - obj.offsetTop - submenuparent.height + submenuparent.label.output.offsetHeight + obj.offsetTop - 3;

			if ((menuleft + submenuparent.width) > parseInt(document.body.clientWidth))
				menuleft = e.x - e.offsetX - obj.offsetLeft - submenuparent.width - 2;
		}
		else
		{
			menutop = e.pageY - e.layerY + submenuparent.label.output.offsetTop - 1;
			menuleft = e.pageX - e.layerX + submenuparent.parent.output.offsetWidth - 2;

			if ((menutop + submenuparent.height) > parseInt(document.body.clientHeight))
				menutop = e.pageY - e.layerY - submenuparent.height + submenuparent.label.output.offsetHeight + submenuparent.label.output.offsetTop - 1;

			if ((menuleft + submenuparent.width) > parseInt(document.body.clientWidth))
				menuleft = e.pageX - e.layerX - submenuparent.width;
		}

		if (obj.menu && obj.menu.output.style.visibility != "visible")
			showMenu(obj,menutop,menuleft);

		document.onclick = hideActiveHidden;
		top.activehidden = obj.menu;
		if (top.activehidden.contextmenu)
			top.showmenus = false;
		else
			top.showmenus = true;
	}

	function hideActiveSubMenu(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		newActive = eval(obj.parentObj);

		if (top.activehidden != newActive)
		{
			top.activehidden.output.style.visibility = "hidden";
			top.activehidden.output.style.display = "none";
		}

		document.onclick = hideActiveHidden;
		top.activehidden = newActive;
	}

	function hideParentsMenus(obj)
	{
		obj.output.style.visibility = "hidden";
		obj.output.style.display = "none";

		if (obj.parent)
			if (obj.parent.type == "JsMenu")
				hideParentsMenus(obj.parent);
	}

	/********************************************
	       General functions for all menus
	********************************************/

	function showMenu(obj,menutop,menuleft)
	{
		if (obj.menu)
		{
			if (top.activehidden && obj.menu != top.activehidden && obj.menu.parent != top.activehidden)
			{
				top.activehidden.output.style.visibility = "hidden";
				top.activehidden.output.style.display = "none";

				if (top.activehidden.parent && top.activehidden.parent.type == "JsMenu" && top.activehidden.parent != obj.menu.parent)
						hideParentsMenus(top.activehidden.parent);
			}

			if (obj.menu)
			{
				obj.menu.output.style.top = menutop;
				obj.menu.output.style.left = menuleft;
				obj.menu.output.style.visibility = "visible";
				obj.menu.output.style.display = "block";
			}
		}
	}

	function hideActiveHidden(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		if (top.activehidden && !obj.donthidemenu)
		{
			if (obj.menu != top.activehidden || (obj.menu.contextmenu && e.type=="click"))
			{
				top.activehidden.output.style.visibility = "hidden";
				top.activehidden.output.style.display = "none";

				if (top.activehidden.parent)
					if (top.activehidden.parent.type == "JsMenu")
						hideParentsMenus(top.activehidden.parent);
			}

			document.onclick = hideActiveHidden;
			top.activehidden = obj.menu;
			if (!obj.menu)
				top.showmenus = false;
		}
	}

	/********************************************
			  End of External Functions
	********************************************/
