
	//Model of jsobject. All should have at least those methods implemented
	JsMenuItem = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsMenuItem";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();
		this.value				= "";

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.output.className	= "menuitem";
		this.menuitemtab		= document.createElement("table");
		this.menuitemtab.className	= "menuitem";
		this.menuitemrow		= this.menuitemtab.insertRow(this.menuitemtab.rows.length);
		this.iconcell			= this.menuitemrow.insertCell(0);
		this.iconcell.style.width = "20";
		this.iconcell.innerHTML = "&nbsp;";
		this.labelcell			= this.menuitemrow.insertCell(1);
		this.labelcell.innerHTML = "&nbsp;";
		this.emptycell			= this.menuitemrow.insertCell(2);
		this.emptycell.style.width = 15;
		this.emptycell.align 	= "center"

		this.icon				= new JsImage();
		this.icon.setHeight("16");
		this.icon.setWidth("16");

		this.arrow				= new JsImage();
		this.arrow.setHeight("7");
		this.arrow.setWidth("4");

		this.output.tab = this.menuitemtab;
		this.menuitemtab.tab = this.menuitemtab;
		this.menuitemrow.tab = this.menuitemtab;
		this.iconcell.tab = this.menuitemtab;
		this.labelcell.tab = this.menuitemtab;
		this.emptycell.tab = this.menuitemtab;
		this.icon.output.tab = this.menuitemtab;
		this.icon.img.tab = this.menuitemtab;
		this.arrow.output.tab = this.menuitemtab;
		this.arrow.img.tab = this.menuitemtab;

		this.output.appendChild(this.menuitemtab);
		this.iconcell.appendChild(this.icon.output);
		this.emptycell.appendChild(this.arrow.output);

		this.setEvent("mouseover",setMenuItemOver);
		this.setEvent("mouseout",setMenuItemOut);
		this.setEvent("click",setMenuItemOut);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsMenuItem.prototype.setAsSubMenu = function()
	{
		this.arrow.setSource("images/left_arrow.gif");
	}

	JsMenuItem.prototype.setIcon = function(value)
	{
		this.icon.setSource(value);
	}
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsMenuItem.prototype.setValue = function(value)
	{
		this.value = value;
		this.labelcell.innerHTML = value;
	}

	JsMenuItem.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("this.menuitemtab." + name + " = \"" + value + "\"");
		eval("this.menuitemrow." + name + " = \"" + value + "\"");
		eval("this.iconcell." + name + " = \"" + value + "\"");
		eval("this.labelcell." + name + " = \"" + value + "\"");
		eval("this.emptycell." + name + " = \"" + value + "\"");
		eval("this.icon.output." + name + " = \"" + value + "\"");
		eval("this.icon.img." + name + " = \"" + value + "\"");
		eval("this.arrow.output." + name + " = \"" + value + "\"");
		eval("this.arrow.img." + name + " = \"" + value + "\"");
	}

	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsMenuItem.prototype.setMenu = function(obj)
	{
		this.output.menu = obj
		this.menuitemtab.menu = obj
		this.menuitemrow.menu = obj
		this.iconcell.menu = obj
		this.labelcell.menu = obj
		this.emptycell.menu = obj
		this.icon.output.menu = obj
		this.icon.img.menu = obj;
		this.arrow.output.menu = obj
		this.arrow.img.menu = obj;
	}
	
	JsMenuItem.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);

		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsMenuItem.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsMenuItem.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/

	/********************************************
				   Visual Methods
	********************************************/
	
	JsMenuItem.prototype.setHeight = function(value)
	{
		this.output.style.height = value
		this.menuitemtab.style.height = value
	}
	
	JsMenuItem.prototype.setWidth = function(value)
	{
		this.output.style.width = value
		this.menuitemtab.style.width = value
	}
	
	JsMenuItem.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsMenuItem.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsMenuItem.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsMenuItem.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsMenuItem.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsMenuItem.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsMenuItem.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsMenuItem.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
				External Functions
	********************************************/
	function setMenuItemOver(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		obj.tab.className = "menuitemover";
	}

	function setMenuItemOut(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		obj.tab.className = "menuitem";
	}
