
	//Model of jsobject. All should have at least those methods implemented
	JsPushButton = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsPushButton";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.output	.style.width = "100%";

		this.bttab				= document.createElement("table");
		this.bttabrow			= this.bttab.insertRow(0);
		this.leftcell			= this.bttabrow.insertCell(0);
		this.content			= this.bttabrow.insertCell(1);
		this.rightcell			= this.bttabrow.insertCell(2);

		this.bttab.className	= "bt";
		this.content.align = "center";
		this.leftcell.style.width = 3;
		this.rightcell.style.width = 3;
		this.leftcell.style.backgroundImage = "url('images/bt_left.gif')";
		this.content.style.backgroundImage = "url('images/bt_center.gif')";
		this.rightcell.style.backgroundImage = "url('images/bt_right.gif')";

		this.label				= new JsLabel;
		this.content.appendChild(this.label.output);

		this.setEvent("mouseover",setBtOver);
		this.setEvent("mouseout",setBtOut);
		this.setEvent("mousedown",setBtDown);
		this.setEvent("mouseup",setBtOver);
		this.setEvent("click",setBtOut);

		this.setAttribute("parent",this.name);

		this.output.appendChild(this.bttab);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsPushButton.prototype.setValue = function(value)
	{
		this.label.setValue(value);
	}

	JsPushButton.prototype.setIcon = function(value)
	{
		this.label.setIcon(value);
		this.label.icon.parent = this.name;
	}

	JsPushButton.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.bttab." + name + " = \"" + value + "\"");
		eval("this.bttabrow." + name + " = \"" + value + "\"");
		eval("this.leftcell." + name + " = \"" + value + "\"");
		eval("this.content." + name + " = \"" + value + "\"");
		eval("this.rightcell." + name + " = \"" + value + "\"");

		this.label.setAttribute(name,value);
	}

	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/

	JsPushButton.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsPushButton.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.leftcell.attachEvent("on" + eventStr, fnc);
			this.rightcell.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.leftcell.addEventListener(eventStr, fnc, false);
			this.rightcell.addEventListener(eventStr, fnc, false);
		}

		this.label.setEvent(eventStr,fnc);
	}

	JsPushButton.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.leftcell.detachEvent("on" + eventStr, fnc);
			this.rightcell.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.leftcell.removeEventListener(eventStr, fnc, false);
			this.rightcell.removeEventListener(eventStr, fnc, false);
		}

		this.label.unsetEvent(eventStr,fnc);
	}

	JsPushButton.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.leftcell.detachEvent("on" + eventStr, fnc);
			this.rightcell.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.leftcell.removeEventListener(eventStr, fnc, false);
			this.rightcell.removeEventListener(eventStr, fnc, false);
		}

		this.label.disableEvent(eventStr,fnc);
	}

	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsPushButton.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsPushButton.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsPushButton.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsPushButton.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsPushButton.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsPushButton.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsPushButton.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsPushButton.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsPushButton.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsPushButton.prototype.disable = function(value)
	{
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	function setBtOver(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		if (obj.parent)
		{
			target = eval(obj.parent);
			target.leftcell.style.backgroundImage = "url('images/bt_over_left.gif')";
			target.content.style.backgroundImage = "url('images/bt_over_center.gif')";
			target.rightcell.style.backgroundImage = "url('images/bt_over_right.gif')";
		}
	}

	function setBtOut(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		if (obj.parent)
		{
			target = eval(obj.parent);
			target.leftcell.style.backgroundImage = "url('images/bt_left.gif')";
			target.content.style.backgroundImage = "url('images/bt_center.gif')";
			target.rightcell.style.backgroundImage = "url('images/bt_right.gif')";
		}
	}

	function setBtDown(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		if (obj.parent)
		{
			target = eval(obj.parent);
			target.leftcell.style.backgroundImage = "url('images/bt_down_left.gif')";
			target.content.style.backgroundImage = "url('images/bt_down_center.gif')";
			target.rightcell.style.backgroundImage = "url('images/bt_down_right.gif')";
		}
	}
