
	//Model of jsobject. All should have at least those methods implemented
	JsRadioButton = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsRadioButton";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		this.orientation		= "v";

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.radiotab			= document.createElement("table");
		this.output.appendChild(this.radiotab);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Content Methods
	********************************************/

	JsRadioButton.prototype.addItem = function(value, label, selected)
	{
		if (!label || label == "")
			label = value;

		index = this.radiotab.rows.length;

		row = this.radiotab.insertRow(index);
		cell = row.insertCell(0);

		if (browserType == "ie")
		{
			if (selected)
				radiobutton = document.createElement("<input type='radio' name='" + this.id + "' checked>");
			else
				radiobutton = document.createElement("<input type='radio' name='" + this.id + "'>");
		}
		else
		{
			radiobutton = document.createElement("input");
			if (selected)
				radiobutton.checked = true;
		}
		radiobutton.type		= "radio";
		radiobutton.id			= this.id + index;
		radiobutton.name		= this.id;
		radiobutton.className	= "lbclick";
		radiobutton.value = value;

		radiolabel				= document.createElement("label");
		radiolabel.htmlFor		= this.id + index;
		radiolabel.className	= "lbclick";
		radiolabel.appendChild(document.createTextNode("  " + label));

		cell.appendChild(radiobutton);
		cell.appendChild(radiolabel);
	}

	JsRadioButton.prototype.delItem = function()
	{
	}

	JsRadioButton.prototype.setItem = function()
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsRadioButton.prototype.getValue = function()
	{
		js_i = 0;
		while (radiobutton = document.getElementById(this.id + js_i))
		{
			if (radiobutton.checked)
				return radiobutton.value;
			js_i++;
		}
	}
	
	JsRadioButton.prototype.setValue = function(value)
	{
		js_i = 0;
		while (radiobutton = document.getElementById(this.id + js_i))
		{
			if (radiobutton.value == value)
				radiobutton.checked = true;
			js_i++;
		}
	}
	
	JsRadioButton.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/

	JsRadioButton.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsRadioButton.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsRadioButton.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsRadioButton.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsRadioButton.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsRadioButton.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsRadioButton.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsRadioButton.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsRadioButton.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsRadioButton.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsRadioButton.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsRadioButton.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsRadioButton.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsRadioButton.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/
