
	//Model of jsobject. All should have at least those methods implemented
	JsRichTextEdit = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsRichTextEdit";
		this.menu				= null;
		this.parent				= null;

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");
		this.output.className	= "lb";

		this.textarea			= document.createElement("textarea");
		this.textarea.className	= "lb";
		this.setEvent("focus",enableSelection);
		this.setEvent("mouseover",enableSelection);
		this.setEvent("blur",disableSelection);
		this.setEvent("mouseout",disableSelection);

		this.output.appendChild(this.textarea)
	}

	/********************************************
				  Exclusive Methods
	********************************************/

	JsRichTextEdit.prototype.setMaxLength = function(value)
	{
		this.textarea.maxLength = value;
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsRichTextEdit.prototype.getValue = function()
	{
		this.value = this.textarea.value;
		return this.value;
	}

	JsRichTextEdit.prototype.setValue = function(value)
	{
		this.value = value;
		this.textarea.value = value;
	}

	JsRichTextEdit.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.textarea." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsRichTextEdit.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsRichTextEdit.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}");
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsRichTextEdit.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsRichTextEdit.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsRichTextEdit.prototype.setHeight = function(value)
	{
		this.output.style.height = value;
		this.textarea.style.height = value;
	}

	JsRichTextEdit.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
		this.textarea.style.width = value;
	}

	JsRichTextEdit.prototype.setClass = function(value)
	{
		this.output.className = value;
		this.textarea.className = value;
	}

	JsRichTextEdit.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value;
		this.textarea.style.cursor = value;
	}

	JsRichTextEdit.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value;
		this.textarea.style.fontFamily = value;
	}
	
	JsRichTextEdit.prototype.setFontColor = function(value)
	{
		this.output.style.color = value;
		this.textarea.style.color = value;
	}
	
	JsRichTextEdit.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value;
	}
	
	JsRichTextEdit.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value;
	}
	
	JsRichTextEdit.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value;
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsRichTextEdit.prototype.disable = function(value)
	{
		this.textarea.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j]);
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j]);
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/
