
	//Model of jsobject. All should have at least those methods implemented
	JsTab = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsTab";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();
		this.tabs			= new Array();
		this.stack				= new JsWidgetStack();

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");

		//Tabs go here
		this.tabsdiv			= document.createElement("div");
		this.tabstab			= document.createElement("table");
		this.tabsrow			= this.tabstab.insertRow(0);

		//content goes here
		this.stackdiv			= document.createElement("div");

		this.tabstab.className = "tabs";
		this.stackdiv.className = "tabsstack";

		this.stack.setHeight(300);

		this.tabsdiv.appendChild(this.tabstab);
		this.stackdiv.appendChild(this.stack.output);

		this.output.appendChild(this.tabsdiv);
		this.output.appendChild(this.stackdiv);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsTab.prototype.addTab = function(label, icon)
	{
		index = this.tabs.length
		this.tabs[index] = this.tabsrow.insertCell(this.tabsrow.cells.length);
		this.tabs[index].className = "tabscell";
		thetab = document.createElement("table");
		thetabrow = thetab.insertRow(0);
		thetableft = thetabrow.insertCell(0);
		thetabcontent = thetabrow.insertCell(1);
		thetabright = thetabrow.insertCell(2);

		tablabel = new JsLabel();
		tablabel.setHeight("100%");
		tablabel.setValue(label);
		if (icon)
			tablabel.setIcon(icon);

		thetab.className = "tabs";

		//Tell the tab who is your daddy
		thetableft.parent = this.name;
		thetabcontent.parent = this.name;
		thetabright.parent = this.name;
		tablabel.setAttribute("parent",this.name);

		//now sets the stackIndex property for this tab
		thetableft.stackIndex = index;
		thetabcontent.stackIndex = index;
		thetabright.stackIndex = index;
		tablabel.setAttribute("stackIndex",index);

		if (index == 0)
		{
			thetableft.style.backgroundImage = "url('images/tab_on_left.gif')";
			thetabcontent.style.backgroundImage = "url('images/tab_on_center.gif')";
			thetabright.style.backgroundImage = "url('images/tab_on_right.gif')";
			thetabcontent.style.vAlign = "top";
		}
		else
		{
			thetableft.style.backgroundImage = "url('images/tab_off_left.gif')";
			thetabcontent.style.backgroundImage = "url('images/tab_off_center.gif')";
			thetabright.style.backgroundImage = "url('images/tab_off_right.gif')";
			thetabcontent.style.vAlign = "bottom"
		}

		if (browserType == "ie")
		{
			thetableft.style.width = 5;
			thetabright.style.width = 5;

			thetableft.attachEvent("onclick", showTab);
			thetabright.attachEvent("onclick", showTab);
		}
		else
		{
			thetableft.style.width = 3;
			thetabright.style.width = 3;

			thetableft.addEventListener("click", showTab, false);
			thetabright.addEventListener("click", showTab, false);
		}

		tablabel.setEvent("click", showTab);
		tablabel.setEvent("click", hideActiveHidden);

		thetabcontent.appendChild(tablabel.output);

		this.tabs[index].appendChild(thetab);

		this.stack.addStack();
	}
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Content Methods
	********************************************/
	
	JsTab.prototype.addItem = function(obj)
	{
		this.childList[this.childList.length] = obj;
		obj.parent = this;

		this.stack.addItem(obj);
	}

	JsTab.prototype.addItemToTab = function(obj, tab_index)
	{
		this.childList[this.childList.length] = obj;
		obj.parent = this;

		this.stack.addItemToStack(obj, tab_index);
	}
	
	JsTab.prototype.delItem = function()
	{
	}
	
	JsTab.prototype.setItem = function()
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsTab.prototype.getValue = function()
	{
	}
	
	JsTab.prototype.setValue = function()
	{
	}

	JsTab.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsTab.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsTab.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsTab.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsTab.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsTab.prototype.setHeight = function(value)
	{
		this.stack.setHeight(value);
		this.output.style.height = value
	}
	
	JsTab.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsTab.prototype.setClass = function(value)
	{
		this.stackdiv.className = value+"stack";
		this.output.className = value
	}
	
	JsTab.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsTab.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsTab.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsTab.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsTab.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsTab.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsTab.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	JsTab.prototype.showTab = function(value)
	{
		this.stack.showStack(value);

		for (i in this.tabs)
		{
			this.tabs[i].firstChild.childNodes[0].rows[0].cells[0].style.backgroundImage = "url('images/tab_off_left.gif')";
			this.tabs[i].firstChild.childNodes[0].rows[0].cells[1].style.backgroundImage = "url('images/tab_off_center.gif')";
			this.tabs[i].firstChild.childNodes[0].rows[0].cells[2].style.backgroundImage = "url('images/tab_off_right.gif')";
		}

		this.tabs[value].firstChild.childNodes[0].rows[0].cells[0].style.backgroundImage = "url('images/tab_on_left.gif')";
		this.tabs[value].firstChild.childNodes[0].rows[0].cells[1].style.backgroundImage = "url('images/tab_on_center.gif')";
		this.tabs[value].firstChild.childNodes[0].rows[0].cells[2].style.backgroundImage = "url('images/tab_on_right.gif')";
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
				External Functions
	********************************************/
	function showTab(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		index = obj.stackIndex;

		targetobj = eval(obj.parent);

		targetobj.stack.showStack(index);

		for (i in targetobj.tabs)
		{
			targetobj.tabs[i].firstChild.childNodes[0].rows[0].cells[0].style.backgroundImage = "url('images/tab_off_left.gif')";
			targetobj.tabs[i].firstChild.childNodes[0].rows[0].cells[1].style.backgroundImage = "url('images/tab_off_center.gif')";
			targetobj.tabs[i].firstChild.childNodes[0].rows[0].cells[2].style.backgroundImage = "url('images/tab_off_right.gif')";
		}

		targetobj.tabs[index].firstChild.childNodes[0].rows[0].cells[0].style.backgroundImage = "url('images/tab_on_left.gif')";
		targetobj.tabs[index].firstChild.childNodes[0].rows[0].cells[1].style.backgroundImage = "url('images/tab_on_center.gif')";
		targetobj.tabs[index].firstChild.childNodes[0].rows[0].cells[2].style.backgroundImage = "url('images/tab_on_right.gif')";
	}
