
	//Model of jsobject. All should have at least those methods implemented
	JsToolBarButton = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsToolBarButton";
		this.menu				= null;
		this.parent				= null;

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");

		this.button				= document.createElement("img");
		this.button.border		= 0;
		this.setEvent("focus",enableSelection);
		this.setEvent("mouseover",enableSelection);
		this.setEvent("blur",disableSelection);
		this.setEvent("mouseout",disableSelection);

		this.output.className = "toolbaritem";
		this.button.className = "toolbaritem";

		this.output.appendChild(this.button);
	}

	/********************************************
				  Exclusive Methods
	********************************************/

	JsToolBarButton.prototype.setSource = function(value)
	{
		this.button.src = value;
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Values Methods
	********************************************/

	JsToolBarButton.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("this.button." + name + " = \"" + value + "\"");
	}

	/********************************************
				End of Values Methods
	********************************************/

	/********************************************
				   Events Methods
	********************************************/

	JsToolBarButton.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsToolBarButton.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}");
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.button.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.button.addEventListener(eventStr, fnc, false);
		}
	}

	JsToolBarButton.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.button.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.button.removeEventListener(eventStr, fnc, false);
		}
	}

	JsToolBarButton.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.button.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.button.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsToolBarButton.prototype.setHeight = function(value)
	{
		this.output.style.height = value;
		this.button.style.height = value;
	}
	
	JsToolBarButton.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
		this.button.style.width = value;
	}
	
	JsToolBarButton.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value;
		this.button.style.cursor = value;
	}

	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsToolBarButton.prototype.disable = function(value)
	{
		this.button.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j]);
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j]);
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/
