
	//Model of jsobject. All should have at least those methods implemented
	JsWidgetGrid = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsWidgetGrid";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");
		
		this.grid				= document.createElement("table");
		this.grid.style.height	= "100%";
		this.grid.style.width	= "100%";
		this.grid.className		= "grid";

		this.output.appendChild(this.grid);
	}

	/********************************************
				  Exclusive Methods
	********************************************/

	JsWidgetGrid.prototype.addRow = function()
	{
		this.currentrow			= this.grid.insertRow(this.grid.rows.length);
	}

	JsWidgetGrid.prototype.addCell = function(width,height,align,valign,colspan,rowspan,bgcolor,bgimage)
	{
		this.currentcell = this.currentrow.insertCell(this.currentrow.cells.length);

		this.currentcell.className = "gridcell";

		if (width)
			this.currentcell.style.width = width;
		if (height)
			this.currentcell.style.height = height;
		if (align)
			this.currentcell.align = align;
		if (valign)
			this.currentcell.style.verticalAlign = valign;
		else
			this.currentcell.style.verticalAlign = "top";
		if (colspan)
			this.currentcell.colSpan = colspan;
		if (rowspan)
			this.currentcell.rowSpan = rowspan;
		if (bgcolor)
			this.currentcell.style.backgroundColor = bgcolor;
		if (bgimage)
			this.currentcell.style.backgroundImage = "url('" + bgimage + "')";
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Content Methods
	********************************************/
	
	JsWidgetGrid.prototype.addItem = function(obj)
	{
		this.childList[this.childList.length] = obj;
		obj.parent = this;
		this.currentcell.appendChild(obj.output);
	}

	JsWidgetGrid.prototype.delItem = function()
	{
	}
	
	JsWidgetGrid.prototype.setItem = function()
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsWidgetGrid.prototype.getValue = function()
	{
	}
	
	JsWidgetGrid.prototype.setValue = function()
	{
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsWidgetGrid.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}

	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsWidgetGrid.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsWidgetGrid.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsWidgetGrid.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsWidgetGrid.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsWidgetGrid.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsWidgetGrid.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsWidgetGrid.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsWidgetGrid.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsWidgetGrid.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/

	/********************************************
				  General Methods
	********************************************/

	JsWidgetGrid.prototype.disable = function()
	{
	}

	/********************************************
			  End of General Methods
	********************************************/
