
	//Model of jsobject. All should have at least those methods implemented
	JsWidgetStack = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsWidgetStack";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();
		this.stacks				= new Array();

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");
		this.output.style.position = "relative";
		this.output.style.width = "100%";
		this.output.style.height = "100";
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsWidgetStack.prototype.addStack = function()
	{
		var index = this.stacks.length;

		this.stacks[index] = document.createElement("div");
		this.stacks[index].style.position = "absolute";
		this.stacks[index].style.width = "100%";
		this.stacks[index].style.height = "100%";
		this.stacks[index].style.top = 0;
		this.stacks[index].style.left = 0;

		if (index == 0)
		{
			this.stacks[index].style.visibility = "visible";
			this.stacks[index].style.display = "block";
		}
		else
		{
			this.stacks[index].style.visibility = "hidden";
			this.stacks[index].style.display = "none";
		}

		this.output.appendChild(this.stacks[index]);
	}

	JsWidgetStack.prototype.delStack = function(index)
	{
		this.output.removeChild(this.stacks[index]);
	}

	JsWidgetStack.prototype.showStack = function(index)
	{
		var index;

		for (i in this.stacks)
		{
			this.stacks[i].style.visibility = "hidden";
			this.stacks[i].style.display = "none";
		}

		this.stacks[index].style.visibility = "visible";
		this.stacks[index].style.display = "block";
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Content Methods
	********************************************/

	JsWidgetStack.prototype.addItem = function(obj)
	{
		stack_index = this.stacks.length - 1;

		this.childList[this.childList.length] = obj;
		obj.parent = this;

		this.stacks[stack_index].appendChild(obj.output);
	}

	JsWidgetStack.prototype.addItemToStack = function(obj, stack_index)
	{
		this.childList[this.childList.length] = obj;
		obj.parent = this;

		this.stacks[stack_index].appendChild(obj.output);
	}

	JsWidgetStack.prototype.delItem = function()
	{
	}
	
	JsWidgetStack.prototype.setItem = function()
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsWidgetStack.prototype.getValue = function()
	{
	}
	
	JsWidgetStack.prototype.setValue = function()
	{
	}

	JsWidgetStack.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsWidgetStack.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsWidgetStack.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsWidgetStack.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsWidgetStack.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/

	/********************************************
				   Visual Methods
	********************************************/
	
	JsWidgetStack.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsWidgetStack.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsWidgetStack.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsWidgetStack.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsWidgetStack.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsWidgetStack.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsWidgetStack.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsWidgetStack.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsWidgetStack.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsWidgetStack.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/
